#! /system/bin/sh

echo " ******************************"
echo " * Starting Wi-Fi calibration *"
echo " ******************************"

HW_MAC=`calibrator get nvs_mac /pds/wifi/nvs_map.bin | grep -o -E "([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}"`

#########################################################################
###
### FakeMAC - MAC Address Randomizer - v3
###
### CHANGE start: 
### This "hook" has been added to the original code in "/system/bin/wifical.sh"
### wich is called by "/init.mapphone_umts.rc" in (the near of) line 275 by
### "service wifi_calibrator /system/bin/sh /system/bin/wifical.sh"
### This "hook"'s purpose is to randomize the WiFi MAC address
#########################################################################
#
set_manual_mac="$1"
fm_target="$( which wifical.sh )"
fm_target_ext_original="original"
fm_filebase="fakemac"
fm_ext_do="do"
fm_ext_on="on"
fm_ext_off="off"
# check if the script is already symlinked
if [ -L "$0" ]; then fm_dir="$( dirname $( readlink $0 ) )"; else fm_dir="$( dirname $0 )"; fi
if [ "$fm_dir" == "." ]; then fm_dir="$( pwd )"; fi
fm="$fm_dir/$fm_filebase"
mount -o remount,rw /system
# move the original into a save location
if [ ! -e "$fm_target.$fm_target_ext_original" ]; then mv "$fm_target" "$fm_target.$fm_target_ext_original"; fi
if [ -e "$fm_target" ]; then rm "$fm_target"; fi
# create symlink to new (this) script
ln -s "$fm.$fm_ext_do" "$fm_target"
mount -o remount,ro /system
# find out the current mode of the randomizer (*.on|*.off|*.keep) by checking the file extension
if [ -e "$fm.$fm_ext_on" ]; then fm_ext="$fm_ext_on"; elif [ -e "$fm.$fm_ext_off" ]; then fm_ext="$fm_ext_off"; else exit; fi;
fm="$fm.$fm_ext"
#DEBUG echo "last debug exit - fm: >$fm< | HW_MAC: >$HW_MAC< | S1: >$1<";exit

### now call the MAC randomizer script ($fm: /data/local/fakemac/fakemac.on|*.off)
HW_MAC=$( "$fm" "$HW_MAC" "$set_manual_mac" )
#
#########################################################################
###
### FakeMAC - MAC Address Randomizer - v3
###
### CHANGE end: 
### This "hook" has been added to the original code in "/system/bin/wifical.sh"
### wich is called by "/init.mapphone_umts.rc" in (the near of) line 275 by
### "service wifi_calibrator /system/bin/sh /system/bin/wifical.sh"
### This "hook"'s purpose is to randomize the WiFi MAC address
#########################################################################

TARGET_FW_DIR=/system/etc/firmware/ti-connectivity
TARGET_NVS_FILE=$TARGET_FW_DIR/wl1271-nvs.bin
TARGET_INI_FILE=/system/etc/wifi/TQS_D_1.7_127x.ini

# Remount system partition as rw
mount -o remount,rw /system

# Actual calibration...
# calibrator plt autocalibrate <dev> <module path> <ini file1> <nvs file> <mac addr>
# Leaving mac address field empty for random mac
#calibrator plt autocalibrate wlan0 $WL12xx_MODULE $TARGET_INI_FILE $TARGET_NVS_FILE $HW_MAC

if [ -e /pds/wifi/nvs_map.bin ];
then
	calibrator set nvs_mac $TARGET_NVS_FILE $HW_MAC
else
	calibrator set nvs_mac $TARGET_NVS_FILE  00:12:34:56:78:90   #Used when nvs_map.bin not exists.
fi

# Remount system partition as ro
mount -o remount,ro /system

echo " ******************************"
echo " * Finished Wi-Fi calibration *"
echo " ******************************"
